﻿//***********************************************************************
//                                                                     
//   doc_log.jsx
//Description:Installiert zwei Event-Listener, die beim Öffnen und Schließen einer Datei in eine Log-Datei schreiben
//                                                                     
//   [Ver: 0.1]   [Author: Gerald Singelmann]   [Modif: 10-07-06]
//   [Lang: DE]   [Req: InDesign CS3/CS4/CS5]   [Creat: 10-07-06]
//                                                                     
//   Bugs & Feedback : gerald{at}cuppascript{dot}com      
//                     www.cuppascript.com    
//                                                                     
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//*********************************************************************
#targetengine "gs_doclog"
main();

function main()
{
	var docWatchListener1 = app.addEventListener("beforeClose",  closing_doc, false);
	var docWatchListener2 = app.addEventListener("afterOpen",  opening_doc, false);
	var the_log = "d:\\doclog.txt";
	 
	 function opening_doc(evt) {
		try {	
			var f = File(the_log);
			if (f.exists) {
				f.open("a");
			} else {
				f.open("w");
			}
			f.writeln("++ opening ++\t" + get_entry(evt.target));
			f.close();
		} catch(e) { }
	}
	 function closing_doc(evt) {
		try {
			var f = File(the_log);
			if (f.exists) {
				f.open("a");
			} else {
				f.open("w");
			}
			f.writeln("-- closing --\t" + get_entry(evt.target));
			f.close();
		} catch(e) {} 
	}
	function get_entry(doc) {
		 try {
				 if (doc.saved) {
					// var crnt_doc_name = doc.name;
					// var crnt_doc_path = unescape(doc.fullName.toString());
					var crnt_doc_path = decodeURI (doc.fullName.toString());
				} else {
					var crnt_doc_path = "Untitled";
				}
				var crnt_version = app.version;

				var crnt_date = new Date();
				crnt_date = crnt_date.toLocaleString();
				
				return crnt_date + "\t" + crnt_doc_path + "\t" + crnt_version;
		} catch(e) { return e}
	}
}

